// ME5xxxPPFO.cpp : implementation file
//

#include "stdafx.h"
#include "Dlg_ME-5xxx.h"
#include "ME5xxxPPFO.h"


// CME5xxxPPFO dialog

IMPLEMENT_DYNAMIC(CME5xxxPPFO, CPropertyPage)

CME5xxxPPFO::CME5xxxPPFO()
	: CME5xxxPP(CME5xxxPPFO::IDD)
{

}

CME5xxxPPFO::~CME5xxxPPFO()
{
}

void CME5xxxPPFO::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CME5xxxPPFO, CPropertyPage)
	ON_BN_CLICKED(IDC_RESET, &CME5xxxPPFO::OnBnClickedReset)
	ON_BN_CLICKED(IDC_WRITE_1, &CME5xxxPPFO::OnBnClickedWrite1)
	ON_BN_CLICKED(IDC_WRITE_2, &CME5xxxPPFO::OnBnClickedWrite2)
	ON_BN_CLICKED(IDC_WRITE_3, &CME5xxxPPFO::OnBnClickedWrite3)
	ON_BN_CLICKED(IDC_WRITE_4, &CME5xxxPPFO::OnBnClickedWrite4)
	ON_BN_CLICKED(IDC_SYNC_WRITE_1, &CME5xxxPPFO::OnBnClickedSyncWrite1)
	ON_BN_CLICKED(IDC_SYNC_WRITE_2, &CME5xxxPPFO::OnBnClickedSyncWrite2)
	ON_BN_CLICKED(IDC_SYNC_WRITE_3, &CME5xxxPPFO::OnBnClickedSyncWrite3)
	ON_BN_CLICKED(IDC_SYNC_WRITE_4, &CME5xxxPPFO::OnBnClickedSyncWrite4)
END_MESSAGE_MAP()


// CME5xxxPPFO message handlers

void CME5xxxPPFO::OnBnClickedReset()
{
	// TODO: Add your control notification handler code here

	int i_me_error = meIOResetSubdevice(m_iDeviceIndex, m_iSubdeviceIndex, ME_IO_RESET_SUBDEVICE_NO_FLAGS);
}

void CME5xxxPPFO::OnBnClickedWrite1()
{
	// TODO: Add your control notification handler code here

	Write(0);
}

void CME5xxxPPFO::OnBnClickedWrite2()
{
	// TODO: Add your control notification handler code here

	Write(1);
}

void CME5xxxPPFO::OnBnClickedWrite3()
{
	// TODO: Add your control notification handler code here

	Write(2);
}

void CME5xxxPPFO::OnBnClickedWrite4()
{
	// TODO: Add your control notification handler code here

	Write(3);
}

void CME5xxxPPFO::OnBnClickedSyncWrite1()
{
	// TODO: Add your control notification handler code here

	SyncWrite(0);
}

void CME5xxxPPFO::OnBnClickedSyncWrite2()
{
	// TODO: Add your control notification handler code here

	SyncWrite(1);
}

void CME5xxxPPFO::OnBnClickedSyncWrite3()
{
	// TODO: Add your control notification handler code here

	SyncWrite(2);
}

void CME5xxxPPFO::OnBnClickedSyncWrite4()
{
	// TODO: Add your control notification handler code here

	SyncWrite(3);
}

BOOL CME5xxxPPFO::OnInitDialog()
{
	CME5xxxPP::OnInitDialog();

	// TODO:  Add extra initialization here

	OnBnClickedReset();

	for(int index_channel = 0; index_channel < 4; index_channel++)
	{
		TCHAR sz_text[64];

		_stprintf_s(&sz_text[0], 64, _T("%f"), 1.0);

		SetDlgItemText( IDC_EDIT_TOTAL_SEC_1 + index_channel, &sz_text[0] );

		_stprintf_s(&sz_text[0], 64, _T("%f"), 0.5);

		SetDlgItemText( IDC_EDIT_PHASE_1_SEC_1 + index_channel, &sz_text[0] );

		CheckDlgButton(IDC_CHECK_SYNC_1, BST_UNCHECKED);

		CheckDlgButton(IDC_CHECK_START_LOW_1, BST_UNCHECKED);

		CheckDlgButton(IDC_CHECK_SOFT_START_1, BST_UNCHECKED);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CME5xxxPPFO :: Write(int iChannelIndex)
{
	TCHAR sz_text[64];

	GetDlgItemText(IDC_EDIT_TOTAL_SEC_1 + iChannelIndex, &sz_text[0], 64);

	double d_total_time = 0.0;

	if( _stscanf_s(&sz_text[0], _T("%lf"), &d_total_time) != 1 )
	{
		AfxMessageBox( _T("Invalid total time") );

		return;
	}

	int i_total_ticks;

	int i_ticks_high_dummy;

	int i_me_error = meIOSingleTimeToTicks(	m_iDeviceIndex,							// Device
											m_iSubdeviceIndex,						// Sub-device
											ME_TIMER_FIO_TOTAL,						// iTimer
											&d_total_time,							// Required time, achieved time retuned here
											&i_total_ticks,							// Ticks low
											&i_ticks_high_dummy,					// Ticks high
											ME_IO_SINGLE_TIME_TO_TICKS_NO_FLAGS	);	// Flags

	GetDlgItemText(IDC_EDIT_PHASE_1_SEC_1 + iChannelIndex, &sz_text[0], 64);

	double d_time_phase_1 = 0.0;

	if( _stscanf_s(&sz_text[0], _T("%lf"), &d_time_phase_1) != 1 )
	{
		AfxMessageBox( _T("Invalid time phase 1") );

		return;
	}

	int i_ticks_phase_1;

	i_me_error = meIOSingleTimeToTicks(	m_iDeviceIndex,								// Device
										m_iSubdeviceIndex,							// Sub-device
										ME_TIMER_FIO_FIRST_PHASE,					// iTimer
										&d_time_phase_1,							// Required time, achieved time retuned here
										&i_ticks_phase_1,							// Ticks low
										&i_ticks_high_dummy,						// Ticks high
										ME_IO_SINGLE_TIME_TO_TICKS_NO_FLAGS		);	// Flags

	i_me_error = meIOSingleConfig(	m_iDeviceIndex,						// Device index
									m_iSubdeviceIndex,					// Subdevice index
									iChannelIndex,						// Channel
									ME_SINGLE_CONFIG_FIO_OUTPUT,		// Single config
									ME_VALUE_NOT_USED,					// Reference 
									ME_TRIG_CHAN_DEFAULT,				// Trigger channel
									ME_TRIG_TYPE_NONE,					// Trigger type
									ME_VALUE_NOT_USED,					// Trigger edge
									ME_IO_SINGLE_CONFIG_NO_FLAGS	);	// Flags

	int i_flags = ME_IO_SINGLE_TYPE_NO_FLAGS;

	if( IsDlgButtonChecked(IDC_CHECK_START_LOW_1 + iChannelIndex) != 0 )
	{
		i_flags|= ME_IO_SINGLE_TYPE_FO_START_LOW;
	}

	if( IsDlgButtonChecked(IDC_CHECK_SOFT_START_1 + iChannelIndex) != 0 )
	{
		i_flags|= ME_IO_SINGLE_TYPE_FO_START_SOFT;
	}

	meIOSingle_t io_single[1];

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= iChannelIndex;
	io_single[0].iDir		= ME_DIR_OUTPUT;
	io_single[0].iValue		= i_total_ticks;
	io_single[0].iTimeOut	= 0;		
	io_single[0].iFlags		= ME_IO_SINGLE_TYPE_FO_UPDATE_ONLY | ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL;
	
	i_me_error = meIOSingle(&io_single[0],				// Output list 
							1,							// Number of elements in the above list 
							ME_IO_SINGLE_NO_FLAGS	);	// Flags

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= iChannelIndex;
	io_single[0].iDir		= ME_DIR_OUTPUT;
	io_single[0].iValue		= i_ticks_phase_1;
	io_single[0].iTimeOut	= 0;		
	io_single[0].iFlags		= i_flags | ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE;
	
	i_me_error = meIOSingle(&io_single[0],				// Output list 
							1,							// Number of elements in the above list 
							ME_IO_SINGLE_NO_FLAGS	);	// Flags
	
	_stprintf_s(&sz_text[0], 64, _T("%f"), d_total_time);

	SetDlgItemText( IDC_EDIT_TOTAL_SEC_1 + iChannelIndex, &sz_text[0] );

	_stprintf_s(&sz_text[0], 64, _T("%f"), d_time_phase_1);

	SetDlgItemText( IDC_EDIT_PHASE_1_SEC_1 + iChannelIndex, &sz_text[0] );
}

void CME5xxxPPFO :: SyncWrite(int iChannelIndex)
{
	TCHAR sz_text[64];

	for(int index_channel = 0; index_channel < 4; index_channel++)
	{
		if( (index_channel != iChannelIndex)&&( IsDlgButtonChecked(IDC_CHECK_SYNC_1 + index_channel) != 0 ) )
		{
			GetDlgItemText(IDC_EDIT_TOTAL_SEC_1 + index_channel, &sz_text[0], 64);

			double d_total_time = 0.0;

			if( _stscanf_s(&sz_text[0], _T("%lf"), &d_total_time) != 1 )
			{
				AfxMessageBox( _T("Invalid total time") );

				return;
			}

			int i_total_ticks;

			int i_ticks_high_dummy;

			int i_me_error = meIOSingleTimeToTicks(	m_iDeviceIndex,							// Device
													m_iSubdeviceIndex,						// Sub-device
													ME_TIMER_FIO_TOTAL,						// iTimer
													&d_total_time,							// Required time, achieved time retuned here
													&i_total_ticks,							// Ticks low
													&i_ticks_high_dummy,					// Ticks high
													ME_IO_SINGLE_TIME_TO_TICKS_NO_FLAGS	);	// Flags

			GetDlgItemText(IDC_EDIT_PHASE_1_SEC_1 + index_channel, &sz_text[0], 64);

			double d_time_phase_1 = 0.0;

			if( _stscanf_s(&sz_text[0], _T("%lf"), &d_time_phase_1) != 1 )
			{
				AfxMessageBox( _T("Invalid time phase 1") );

				return;
			}

			int i_ticks_phase_1;

			i_me_error = meIOSingleTimeToTicks(	m_iDeviceIndex,								// Device
												m_iSubdeviceIndex,							// Sub-device
												ME_TIMER_FIO_FIRST_PHASE,					// iTimer
												&d_time_phase_1,							// Required time, achieved time retuned here
												&i_ticks_phase_1,							// Ticks low
												&i_ticks_high_dummy,						// Ticks high
												ME_IO_SINGLE_TIME_TO_TICKS_NO_FLAGS		);	// Flags

			i_me_error = meIOSingleConfig(	m_iDeviceIndex,						// Device index
											m_iSubdeviceIndex,					// Subdevice index
											index_channel,						// Channel
											ME_SINGLE_CONFIG_FIO_OUTPUT,		// Single config
											ME_VALUE_NOT_USED,					// Reference 
											ME_TRIG_CHAN_SYNCHRONOUS,			// Trigger channel
											ME_TRIG_TYPE_NONE,					// Trigger type
											ME_VALUE_NOT_USED,					// Trigger edge
											ME_IO_SINGLE_CONFIG_NO_FLAGS	);	// Flags

			int i_flags = ME_IO_SINGLE_TYPE_NO_FLAGS;

			if( IsDlgButtonChecked(IDC_CHECK_START_LOW_1 + index_channel) != 0 )
			{
				i_flags|= ME_IO_SINGLE_TYPE_FO_START_LOW;
			}

			if( IsDlgButtonChecked(IDC_CHECK_SOFT_START_1 + index_channel) != 0 )
			{
				i_flags|= ME_IO_SINGLE_TYPE_FO_START_SOFT;
			}

			meIOSingle_t io_single[1];

			io_single[0].iDevice = m_iDeviceIndex;

			io_single[0].iSubdevice = m_iSubdeviceIndex;
			io_single[0].iChannel	= index_channel;
			io_single[0].iDir		= ME_DIR_OUTPUT;
			io_single[0].iValue		= i_total_ticks;
			io_single[0].iTimeOut	= 0;		
			io_single[0].iFlags		= ME_IO_SINGLE_TYPE_FO_UPDATE_ONLY | ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL;
			
			i_me_error = meIOSingle(&io_single[0],				// Output list 
									1,							// Number of elements in the above list 
									ME_IO_SINGLE_NO_FLAGS	);	// Flags

			io_single[0].iDevice = m_iDeviceIndex;

			io_single[0].iSubdevice = m_iSubdeviceIndex;
			io_single[0].iChannel	= index_channel;
			io_single[0].iDir		= ME_DIR_OUTPUT;
			io_single[0].iValue		= i_ticks_phase_1;
			io_single[0].iTimeOut	= 0;		
			io_single[0].iFlags		= i_flags | ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE;
			
			i_me_error = meIOSingle(&io_single[0],				// Output list 
									1,							// Number of elements in the above list 
									ME_IO_SINGLE_NO_FLAGS	);	// Flags
			
			_stprintf_s(&sz_text[0], 64, _T("%f"), d_total_time);

			SetDlgItemText( IDC_EDIT_TOTAL_SEC_1 + index_channel, &sz_text[0] );

			_stprintf_s(&sz_text[0], 64, _T("%f"), d_time_phase_1);

			SetDlgItemText( IDC_EDIT_PHASE_1_SEC_1 + index_channel, &sz_text[0] );
		}
	}

	GetDlgItemText(IDC_EDIT_TOTAL_SEC_1 + iChannelIndex, &sz_text[0], 64);

	double d_total_time = 0.0;

	if( _stscanf_s(&sz_text[0], _T("%lf"), &d_total_time) != 1 )
	{
		AfxMessageBox( _T("Invalid total time") );

		return;
	}

	int i_total_ticks;

	int i_ticks_high_dummy;

	int i_me_error = meIOSingleTimeToTicks(	m_iDeviceIndex,							// Device
											m_iSubdeviceIndex,						// Sub-device
											ME_TIMER_FIO_TOTAL,						// iTimer
											&d_total_time,							// Required time, achieved time retuned here
											&i_total_ticks,							// Ticks low
											&i_ticks_high_dummy,					// Ticks high
											ME_IO_SINGLE_TIME_TO_TICKS_NO_FLAGS	);	// Flags

	GetDlgItemText(IDC_EDIT_PHASE_1_SEC_1 + iChannelIndex, &sz_text[0], 64);

	double d_time_phase_1 = 0.0;

	if( _stscanf_s(&sz_text[0], _T("%lf"), &d_time_phase_1) != 1 )
	{
		AfxMessageBox( _T("Invalid time phase 1") );

		return;
	}

	int i_ticks_phase_1;

	i_me_error = meIOSingleTimeToTicks(	m_iDeviceIndex,								// Device
										m_iSubdeviceIndex,							// Sub-device
										ME_TIMER_FIO_FIRST_PHASE,					// iTimer
										&d_time_phase_1,							// Required time, achieved time retuned here
										&i_ticks_phase_1,							// Ticks low
										&i_ticks_high_dummy,						// Ticks high
										ME_IO_SINGLE_TIME_TO_TICKS_NO_FLAGS		);	// Flags

	i_me_error = meIOSingleConfig(	m_iDeviceIndex,						// Device index
									m_iSubdeviceIndex,					// Subdevice index
									iChannelIndex,						// Channel
									ME_SINGLE_CONFIG_FIO_OUTPUT,		// Single config
									ME_VALUE_NOT_USED,					// Reference 
									ME_TRIG_CHAN_DEFAULT,				// Trigger channel
									ME_TRIG_TYPE_NONE,					// Trigger type
									ME_VALUE_NOT_USED,					// Trigger edge
									ME_IO_SINGLE_CONFIG_NO_FLAGS	);	// Flags

	int i_flags = ME_IO_SINGLE_TYPE_NO_FLAGS;

	if( IsDlgButtonChecked(IDC_CHECK_START_LOW_1 + iChannelIndex) != 0 )
	{
		i_flags|= ME_IO_SINGLE_TYPE_FO_START_LOW;
	}

	if( IsDlgButtonChecked(IDC_CHECK_SOFT_START_1 + iChannelIndex) != 0 )
	{
		i_flags|= ME_IO_SINGLE_TYPE_FO_START_SOFT;
	}

	meIOSingle_t io_single[1];

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= iChannelIndex;
	io_single[0].iDir		= ME_DIR_OUTPUT;
	io_single[0].iValue		= i_total_ticks;
	io_single[0].iTimeOut	= 0;		
	io_single[0].iFlags		= ME_IO_SINGLE_TYPE_FO_UPDATE_ONLY | ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL;
	
	i_me_error = meIOSingle(&io_single[0],				// Output list 
							1,							// Number of elements in the above list 
							ME_IO_SINGLE_NO_FLAGS	);	// Flags

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= iChannelIndex;
	io_single[0].iDir		= ME_DIR_OUTPUT;
	io_single[0].iValue		= i_ticks_phase_1;
	io_single[0].iTimeOut	= 0;		
	io_single[0].iFlags		= i_flags | ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE | ME_IO_SINGLE_TYPE_TRIG_SYNCHRONOUS;
	
	i_me_error = meIOSingle(&io_single[0],				// Output list 
							1,							// Number of elements in the above list 
							ME_IO_SINGLE_NO_FLAGS	);	// Flags
	
	_stprintf_s(&sz_text[0], 64, _T("%f"), d_total_time);

	SetDlgItemText( IDC_EDIT_TOTAL_SEC_1 + iChannelIndex, &sz_text[0] );

	_stprintf_s(&sz_text[0], 64, _T("%f"), d_time_phase_1);

	SetDlgItemText( IDC_EDIT_PHASE_1_SEC_1 + iChannelIndex, &sz_text[0] );
}

