// ME5xxxPropertySheet.cpp : implementation file
//

#include "stdafx.h"
#include "Dlg_ME-5xxx.h"
#include "ME5xxxPropertySheet.h"


// CME5xxxPropertySheet

IMPLEMENT_DYNAMIC(CME5xxxPropertySheet, CPropertySheet)

CME5xxxPropertySheet::CME5xxxPropertySheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{

}

CME5xxxPropertySheet::CME5xxxPropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{

}

CME5xxxPropertySheet::~CME5xxxPropertySheet()
{
}


BEGIN_MESSAGE_MAP(CME5xxxPropertySheet, CPropertySheet)
END_MESSAGE_MAP()


// CME5xxxPropertySheet message handlers

BOOL CME5xxxPropertySheet::OnInitDialog()
{
	BOOL bResult = CPropertySheet::OnInitDialog();

	// TODO:  Add your specialized code here

	HWND hWnd = ::GetDlgItem(m_hWnd, IDHELP);

	if (hWnd != NULL)
	{
		::ShowWindow(hWnd, SW_HIDE);
		::EnableWindow(hWnd, FALSE);
	}

	hWnd = ::GetDlgItem(m_hWnd, ID_APPLY_NOW);

	if (hWnd != NULL)
	{
		::ShowWindow(hWnd, SW_HIDE);
		::EnableWindow(hWnd, FALSE);
	}

	hWnd = ::GetDlgItem(m_hWnd, IDCANCEL);

	if (hWnd != NULL)
	{
		::ShowWindow(hWnd, SW_HIDE);
		::EnableWindow(hWnd, FALSE);
	}

	hWnd = ::GetDlgItem(m_hWnd, IDOK);

	if (hWnd != NULL)
	{
		::ShowWindow(hWnd, SW_HIDE);
		::EnableWindow(hWnd, FALSE);
	}

	// resize the tab control

	hWnd = (HWND)::GetDlgItem(m_hWnd, AFX_IDC_TAB_CONTROL);

	ASSERT(hWnd != NULL);

	CRect rectOld;

	::GetWindowRect(hWnd, &rectOld);

	ScreenToClient(rectOld);

	GetWindowRect(&rectOld);

	SetWindowPos(NULL, 0, 0, rectOld.Width(), rectOld.Height() - 32, SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);

	return bResult;
}
